/***************************************************************************
 *   Copyright (C) 2007 by Andreas Theofilu                                *
 *   andreas@TheoSys.at                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation version 3 of the License.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TILGUNGSPLANWIDGET_H
#define TILGUNGSPLANWIDGET_H

#include "tilgungsplanwidgetbase.h"
#include "tilgplan.h"

class tilgungsplanWidget : public tilgungsplanWidgetBase
{
		Q_OBJECT

	public:
		tilgungsplanWidget ( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
		~tilgungsplanWidget();
		/*$PUBLIC_FUNCTIONS$*/

	public slots:
		/*$PUBLIC_SLOTS$*/
		virtual void          mnCalcTPSumSlot();
		virtual void          txRaDezSlot();
		virtual void          txRaNovSlot();
		virtual void          txRaOktSlot();
		virtual void          txRaSepSlot();
		virtual void          txRaAugSlot();
		virtual void          txRaJulSlot();
		virtual void          txRaJunSlot();
		virtual void          txRaMaiSlot();
		virtual void          txRaMarSlot();
		virtual void          txRaFebSlot();
		virtual void          txRaJanSlot();
		virtual void          txRaAprSlot();
		virtual void          txGesBelastSlot();
		virtual void          txEffZiSlot();
		virtual void          intAnzRatenSlot();
		virtual void          numAnnZuschSlot();
		virtual void          dtZiGiltAbSlot();
		virtual void          dtRaVonSlot();
		virtual void          dtRaBisSlot();
		virtual void          dtEndfaelSlot();
		virtual void          dtAuszahlSlot();
		virtual void          dtAbschlussSlot();
		virtual void          lbRatartSlot();
		virtual void          cbZiChangeSlot();
		virtual void          cbUltimoSlot();
		virtual void          cbRateSlot();
		virtual void          mnCalcTPSlot();
		virtual void          mnInputZiSlot();
		virtual void          lbVerzartSlot();
		virtual void          lbTageberSlot();
		virtual void          numZuzaehlSlot();
		virtual void          numBeaGebSlot();
		virtual void          numZisatzSlot();
		virtual void          numZiZuschSlot();
		virtual void          numRateSlot();
		virtual void          numFixspesenSlot();
		virtual void          numKostenSlot();
		virtual void          cbRundenSlot();
		virtual void          numBetragSlot();
		virtual void          helpAbout();
		virtual void          helpContents();
		virtual void          helpIndex();
		virtual void          editFind();
		virtual void          editPaste();
		virtual void          editCopy();
		virtual void          editCut();
		virtual void          editRedo();
		virtual void          editUndo();
		virtual void          fileExit();
		virtual void          filePrint();
		virtual void          fileSaveAs();
		virtual void          fileSave();
		virtual void          fileOpen();
		virtual void          fileNew();
		virtual void          lbValutaSlot();
		virtual void          cbAbschlSlot();
		virtual void          rbZuschPSlot();
		virtual void          rbZuschFSlot();

	protected:
		/*$PROTECTED_FUNCTIONS$*/

	protected slots:
		/*$PROTECTED_SLOTS$*/

	private:
		void moveValues();
		void readValues(const char *fname, BOOL home);
		void readValues(const char *fname) { readValues(fname, FALSE); }
		void readValues() { readValues("/.tilgpars.dat", TRUE); }

		QWidget *mamma;
		TPPARS TpPars;
		BOOL dirty;
};

#endif

